diff --git a/avr/cores/tiny/wiring_analog.c b/avr/cores/tiny/wiring_analog.c
index eb86e8ce..f06c9f39 100644
--- a/avr/cores/tiny/wiring_analog.c
+++ b/avr/cores/tiny/wiring_analog.c
@@ -63,13 +63,7 @@ void analogReference(uint8_t mode)
 
 int analogRead(uint8_t pin)
 {
-	
-  #if defined( NUM_DIGITAL_PINS ) && !defined(ANALOG_PINS_SEPARATE)
-  if ( pin >= NUM_DIGITAL_PINS ) pin -= NUM_DIGITAL_PINS; // allow for channel or pin numbers
-  #endif
-  
-  // fix? Validate pin?
-  //if(pin >= NUM_ANALOG_INPUTS) return 0; //Not a valid pin.
+  pin &=127; //strip off the high bit of the A# constants
   #ifndef ADCSRA
   return digitalRead(analogInputToDigitalPin(pin)) ? 1023 : 0; //No ADC, so read as a digital pin instead.
   #endif
diff --git a/avr/cores/tiny/wiring_digital.c b/avr/cores/tiny/wiring_digital.c
index 52fff0a7..cfbd9b21 100644
--- a/avr/cores/tiny/wiring_digital.c
+++ b/avr/cores/tiny/wiring_digital.c
@@ -31,6 +31,7 @@
 
 void pinMode(uint8_t pin, uint8_t mode)
 {
+	if (pin&128) {pin=analogInputToDigitalPin(pin&127);}
 	uint8_t bit = digitalPinToBitMask(pin);
 	uint8_t port = digitalPinToPort(pin);
 	volatile uint8_t *reg, *out;
@@ -117,6 +118,7 @@ static void turnOffPWM(uint8_t timer)
 
 void digitalWrite(uint8_t pin, uint8_t val)
 {
+	if (pin&128) {pin=analogInputToDigitalPin(pin&127);}
 	uint8_t timer = digitalPinToTimer(pin);
 	uint8_t bit = digitalPinToBitMask(pin);
 	uint8_t port = digitalPinToPort(pin);
@@ -145,6 +147,7 @@ void digitalWrite(uint8_t pin, uint8_t val)
 
 int digitalRead(uint8_t pin)
 {
+	if (pin&128) {pin=analogInputToDigitalPin(pin&127);}
 	uint8_t timer = digitalPinToTimer(pin);
 	uint8_t bit = digitalPinToBitMask(pin);
 	uint8_t port = digitalPinToPort(pin);
diff --git a/avr/cores/tinymodern/core_pins.h b/avr/cores/tinymodern/core_pins.h
index 4f971f77..2834cb31 100644
--- a/avr/cores/tinymodern/core_pins.h
+++ b/avr/cores/tinymodern/core_pins.h
@@ -55,7 +55,7 @@
 #define CORE_DIGITAL_COUNT    (CORE_DIGITAL_LAST-CORE_DIGITAL_FIRST+1)
 #define CORE_RESET_INCLUDED   (1)
 
-#define CORE_ANALOG_FIRST     (0)
+#define CORE_ANALOG_FIRST     (64)
 #define CORE_ANALOG_COUNT     (12)
 #define CORE_ANALOG_LAST      (CORE_ANALOG_FIRST+CORE_ANALOG_COUNT-1)
 
@@ -130,7 +130,7 @@
 #define CORE_DIGITAL_COUNT    (CORE_DIGITAL_LAST-CORE_DIGITAL_FIRST+1)
 #define CORE_RESET_INCLUDED   (1)
 
-#define CORE_ANALOG_FIRST     (CORE_DIGITAL_LAST+1)
+#define CORE_ANALOG_FIRST     (64)
 #define CORE_ANALOG_COUNT     (13) // 12 + internal temperature sensor
 #define CORE_ANALOG_LAST      (CORE_ANALOG_FIRST+CORE_ANALOG_COUNT-1)
 
@@ -197,12 +197,12 @@
 #define LED_BUILTIN (13)
 
 #define CORE_DIGITAL_FIRST    (0)
-#define CORE_DIGITAL_LAST     (27)
+#define CORE_DIGITAL_LAST     (28)
 #define CORE_DIGITAL_COUNT    (CORE_DIGITAL_LAST-CORE_DIGITAL_FIRST+1)
 #define CORE_RESET_INCLUDED   (1)
 
 #define CORE_ANALOG_FIRST     (0)
-#define CORE_ANALOG_COUNT     (27) // 12 + internal temperature sensor
+#define CORE_ANALOG_COUNT     (28)
 #define CORE_ANALOG_LAST      (CORE_ANALOG_FIRST+CORE_ANALOG_COUNT-1)
 
 #define CORE_INT0_PIN  PIN_C1
diff --git a/avr/cores/tinymodern/pins_arduino.h b/avr/cores/tinymodern/pins_arduino.h
index ecf5e51e..7d81b2e2 100644
--- a/avr/cores/tinymodern/pins_arduino.h
+++ b/avr/cores/tinymodern/pins_arduino.h
@@ -102,6 +102,8 @@ extern const uint8_t PROGMEM port_to_pullup_PGM[];
 #define portPcMaskRegister(P) (P==1?&PCMSK0:(P?&PCMSK2:NOT_A_PORT ))
 #define portPullupRegister(P) (P==1?&PUEA:(P?&PUEB:NOT_A_PORT ))
 
+#define analogInputToDigitalPin(p)  ((p < 9) ? 10 -(p): (p==9)?11:(11-(p)))
+
 #define digitalPinToPCICR(p)    (((p) >= 0 && (p) <= 10) ? (&GIMSK) : ((uint8_t *)NULL))
 #define digitalPinToPCICRbit(p) (((p) <= 2) ? PCIE1 : PCIE0)
 #define digitalPinToPCMSK(p)    (((p) <= 2) ? (&PCMSK1) : (((p) <= 10) ? (&PCMSK0) : ((uint8_t *)NULL)))
@@ -159,6 +161,7 @@ extern const uint8_t PROGMEM port_to_pullup_PGM[];
 #define digitalPinToPCMSKbit(p) digitalPinToPCX( p, p,       8-p,     14-p,    13-p,    17-p,    0    )
 
 
+#define analogInputToDigitalPin(p)  ((p < 6) ? 5 -(p):(22-(p)))
 
 #endif
 
@@ -173,6 +176,8 @@ extern const uint8_t PROGMEM port_to_pullup_PGM[];
 #define SCK 27
 
 
+#define analogInputToDigitalPin(p)  (p)
+
 #define digitalPinToPCICR(p)    (&PCICR)
 #define digitalPinToPCICRbit(p) (1<<(p>>3))
 #define digitalPinToPCMSK(p)    (p<8?&PCMSK0:(p<16?&PCMSK1:(p<24?&PCMSK2:&PCMSK3)))
diff --git a/avr/cores/tinymodern/wiring_analog.c b/avr/cores/tinymodern/wiring_analog.c
index 46ad1ef9..f6cb8cb1 100644
--- a/avr/cores/tinymodern/wiring_analog.c
+++ b/avr/cores/tinymodern/wiring_analog.c
@@ -46,7 +46,12 @@ void analogReference(uint8_t mode)
 
 int analogRead(int8_t pin)
 {
-  pin&=127; //This should be called with an A# constant (channel number + 128), or a channel number. 
+  //#if defined( CORE_ANALOG_FIRST )
+  //  if ( pin >= CORE_ANALOG_FIRST ) pin -= CORE_ANALOG_FIRST; // allow for channel or pin numbers
+  //#endif
+  #ifndef __AVR_ATtiny828__
+  if (pin & 64) {pin=pin&63;}
+  #endif
 
   ADC_SetVoltageReference( analog_reference );
   ADC_SetInputChannel( pin );
diff --git a/avr/cores/tinymodern/wiring_digital.c b/avr/cores/tinymodern/wiring_digital.c
index 81a71663..1dee04e1 100644
--- a/avr/cores/tinymodern/wiring_digital.c
+++ b/avr/cores/tinymodern/wiring_digital.c
@@ -35,6 +35,9 @@
 #if defined(__AVR_ATtinyX41__ ) || defined(__AVR_ATtiny1634__) || defined(__AVR_ATtiny828__)
 void pinMode(uint8_t pin, uint8_t mode)
 {
+  #ifndef __AVR_ATtiny828__
+  if (pin&64) {pin=analogInputToDigitalPin(pin&63);}
+  #endif
   uint8_t bit = digitalPinToBitMask(pin);
   uint8_t port = digitalPinToPort(pin);
   volatile uint8_t *reg, *out, *pue;
@@ -72,6 +75,9 @@ void pinMode(uint8_t pin, uint8_t mode)
 
 void pinMode(uint8_t pin, uint8_t mode)
 {
+  #ifndef __AVR_ATtiny828__
+  if (pin&64) {pin=analogInputToDigitalPin(pin&63);}
+  #endif
   uint8_t bit = digitalPinToBitMask(pin);
   uint8_t port = digitalPinToPort(pin);
   volatile uint8_t *reg, *out;
@@ -173,6 +179,9 @@ __attribute__((always_inline)) static inline void turnOffPWM( uint8_t pin )
 
 void digitalWrite(uint8_t pin, uint8_t val)
 {
+  #ifndef __AVR_ATtiny828__
+  if (pin&64) {pin=analogInputToDigitalPin(pin&63);}
+  #endif
   uint8_t bit = digitalPinToBitMask(pin);
   uint8_t port = digitalPinToPort(pin);
   volatile uint8_t *out, *pue;
@@ -204,6 +213,9 @@ void digitalWrite(uint8_t pin, uint8_t val)
 
 void digitalWrite(uint8_t pin, uint8_t val)
 {
+  #ifndef __AVR_ATtiny828__
+  if (pin&64) {pin=analogInputToDigitalPin(pin&63);}
+  #endif
   uint8_t bit = digitalPinToBitMask(pin);
   uint8_t port = digitalPinToPort(pin);
   volatile uint8_t *out;
@@ -232,6 +244,7 @@ void digitalWrite(uint8_t pin, uint8_t val)
 
 int digitalRead(uint8_t pin)
 {
+  if (pin&128) {pin=analogInputToDigitalPin(pin&127);}
 	uint8_t bit = digitalPinToBitMask(pin);
 	uint8_t port = digitalPinToPort(pin);
 
diff --git a/avr/variants/tinyX4/pins_arduino.h b/avr/variants/tinyX4/pins_arduino.h
index 5eeeeca5..beb729b5 100644
--- a/avr/variants/tinyX4/pins_arduino.h
+++ b/avr/variants/tinyX4/pins_arduino.h
@@ -71,14 +71,14 @@ static const uint8_t SDA = 4;
 static const uint8_t SCL = 6;
 
 //Ax constants cannot be used for digitalRead/digitalWrite/analogWrite functions, only analogRead().
-static const uint8_t A0 = 0;
-static const uint8_t A1 = 1;
-static const uint8_t A2 = 2;
-static const uint8_t A3 = 3;
-static const uint8_t A4 = 4;
-static const uint8_t A5 = 5;
-static const uint8_t A6 = 6;
-static const uint8_t A7 = 7;
+static const uint8_t A0 = 0x80 & 0;
+static const uint8_t A1 = 0x80 & 1;
+static const uint8_t A2 = 0x80 & 2;
+static const uint8_t A3 = 0x80 & 3;
+static const uint8_t A4 = 0x80 & 4;
+static const uint8_t A5 = 0x80 & 5;
+static const uint8_t A6 = 0x80 & 6;
+static const uint8_t A7 = 0x80 & 7;
 
 #define PIN_A0  (10)
 #define PIN_A1  ( 9)
diff --git a/avr/variants/tinyX4_reverse/pins_arduino.h b/avr/variants/tinyX4_reverse/pins_arduino.h
index e9a558a4..d6f9ad9c 100644
--- a/avr/variants/tinyX4_reverse/pins_arduino.h
+++ b/avr/variants/tinyX4_reverse/pins_arduino.h
@@ -73,14 +73,14 @@ static const uint8_t SCL = 4;
 
 //Ax constants should not be used for digitalRead/digitalWrite/analogWrite functions, only analogRead().
 //#define ANALOG_PINS_ARE_ADC_NUMBERS 1
-static const uint8_t A0 = 0;
-static const uint8_t A1 = 1;
-static const uint8_t A2 = 2;
-static const uint8_t A3 = 3;
-static const uint8_t A4 = 4;
-static const uint8_t A5 = 5;
-static const uint8_t A6 = 6;
-static const uint8_t A7 = 7;
+static const uint8_t A0 = 0x80 & 0;
+static const uint8_t A1 = 0x80 & 1;
+static const uint8_t A2 = 0x80 & 2;
+static const uint8_t A3 = 0x80 & 3;
+static const uint8_t A4 = 0x80 & 4;
+static const uint8_t A5 = 0x80 & 5;
+static const uint8_t A6 = 0x80 & 6;
+static const uint8_t A7 = 0x80 & 7;
 #define PIN_A0  (0)
 #define PIN_A1  ( 1)
 #define PIN_A2  ( 2)
diff --git a/avr/variants/tinyX5/pins_arduino.h b/avr/variants/tinyX5/pins_arduino.h
index 3aef3c30..e1744cf4 100644
--- a/avr/variants/tinyX5/pins_arduino.h
+++ b/avr/variants/tinyX5/pins_arduino.h
@@ -71,10 +71,10 @@ static const uint8_t SDA = 0;
 static const uint8_t SCL = 2;
 
 //Ax constants cannot be used for digitalRead/digitalWrite/analogWrite functions, only analogRead().
-static const uint8_t A0 = 0;
-static const uint8_t A1 = 1;
-static const uint8_t A2 = 2;
-static const uint8_t A3 = 3;
+static const uint8_t A0 = 0x80 & 0;
+static const uint8_t A1 = 0x80 & 1;
+static const uint8_t A2 = 0x80 & 2;
+static const uint8_t A3 = 0x80 & 3;
 
 #define PIN_B0  ( 0)
 #define PIN_B1  ( 1)
diff --git a/avr/variants/tinyX61/pins_arduino.h b/avr/variants/tinyX61/pins_arduino.h
index d814664e..0f479d2f 100644
--- a/avr/variants/tinyX61/pins_arduino.h
+++ b/avr/variants/tinyX61/pins_arduino.h
@@ -70,17 +70,17 @@ static const uint8_t SDA = 0;
 static const uint8_t SCL = 2;
 
 //Ax constants cannot be used for digitalRead/digitalWrite/analogWrite functions, only analogRead().
-static const uint8_t A0 = 0;
-static const uint8_t A1 = 1;
-static const uint8_t A2 = 2;
-static const uint8_t A3 = 3;
-static const uint8_t A4 = 4;
-static const uint8_t A5 = 5;
-static const uint8_t A6 = 6;
-static const uint8_t A7 = 7;
-static const uint8_t A8 = 8;
-static const uint8_t A9 = 9;
-static const uint8_t A10 = 10;
+static const uint8_t A0 = 0x80 & 0;
+static const uint8_t A1 = 0x80 & 1;
+static const uint8_t A2 = 0x80 & 2;
+static const uint8_t A3 = 0x80 & 3;
+static const uint8_t A4 = 0x80 & 4;
+static const uint8_t A5 = 0x80 & 5;
+static const uint8_t A6 = 0x80 & 6;
+static const uint8_t A7 = 0x80 & 7;
+static const uint8_t A8 = 0x80 & 8;
+static const uint8_t A9 = 0x80 & 9;
+static const uint8_t A10 = 0x80 & 10;
 
 #define PIN_A0  (0)
 #define PIN_A1  ( 1)
diff --git a/avr/variants/tinyX7/pins_arduino.h b/avr/variants/tinyX7/pins_arduino.h
index f4f3b073..97f73bb5 100644
--- a/avr/variants/tinyX7/pins_arduino.h
+++ b/avr/variants/tinyX7/pins_arduino.h
@@ -66,17 +66,17 @@
 #endif
 
 //Ax constants cannot be used for digitalRead/digitalWrite/analogWrite functions, only analogRead().
-static const uint8_t A0 = 0;
-static const uint8_t A1 = 1;
-static const uint8_t A2 = 2;
-static const uint8_t A3 = 3;
-static const uint8_t A4 = 4;
-static const uint8_t A5 = 5;
-static const uint8_t A6 = 6;
-static const uint8_t A7 = 7;
-static const uint8_t A8 = 8;
-static const uint8_t A9 = 9;
-static const uint8_t A10 = 10;
+static const uint8_t A0 = 0x80 & 0;
+static const uint8_t A1 = 0x80 & 1;
+static const uint8_t A2 = 0x80 & 2;
+static const uint8_t A3 = 0x80 & 3;
+static const uint8_t A4 = 0x80 & 4;
+static const uint8_t A5 = 0x80 & 5;
+static const uint8_t A6 = 0x80 & 6;
+static const uint8_t A7 = 0x80 & 7;
+static const uint8_t A8 = 0x80 & 8;
+static const uint8_t A9 = 0x80 & 9;
+static const uint8_t A10 = 0x80 & 10;
 #define LED_BUILTIN (4)
 
 //----------------------------------------------------------
diff --git a/avr/variants/tinyX7_New/pins_arduino.h b/avr/variants/tinyX7_New/pins_arduino.h
index 7d47287f..e97f620c 100644
--- a/avr/variants/tinyX7_New/pins_arduino.h
+++ b/avr/variants/tinyX7_New/pins_arduino.h
@@ -69,17 +69,17 @@
 #define SCL 5
 
 //Ax constants cannot be used for digitalRead/digitalWrite/analogWrite functions, only analogRead().
-static const uint8_t A0 = 0;
-static const uint8_t A1 = 1;
-static const uint8_t A2 = 2;
-static const uint8_t A3 = 3;
-static const uint8_t A4 = 4;
-static const uint8_t A5 = 5;
-static const uint8_t A6 = 6;
-static const uint8_t A7 = 7;
-static const uint8_t A8 = 8;
-static const uint8_t A9 = 9;
-static const uint8_t A10 = 10;
+static const uint8_t A0 = 0x80 & 0;
+static const uint8_t A1 = 0x80 & 1;
+static const uint8_t A2 = 0x80 & 2;
+static const uint8_t A3 = 0x80 & 3;
+static const uint8_t A4 = 0x80 & 4;
+static const uint8_t A5 = 0x80 & 5;
+static const uint8_t A6 = 0x80 & 6;
+static const uint8_t A7 = 0x80 & 7;
+static const uint8_t A8 = 0x80 & 8;
+static const uint8_t A9 = 0x80 & 9;
+static const uint8_t A10 = 0x80 & 10;
 #define LED_BUILTIN (3)
 
 #define PIN_A0  ( 0)
diff --git a/avr/variants/tinyX8/pins_arduino.h b/avr/variants/tinyX8/pins_arduino.h
index 9b6a322d..648e88c4 100644
--- a/avr/variants/tinyX8/pins_arduino.h
+++ b/avr/variants/tinyX8/pins_arduino.h
@@ -35,7 +35,7 @@
 
 #define NUM_DIGITAL_PINS            17
 #define NUM_ANALOG_INPUTS           8
-#define analogInputToDigitalPin(p)  ((p < 6) ? (p) + 16 : -1)
+#define analogInputToDigitalPin(p)  ((p < 8) ? (p) + 17 : -1)
 
 #define digitalPinHasPWM(p)         ((p) == 9 || (p) == 10)
 
@@ -77,18 +77,18 @@ static const uint8_t MOSI = 11;
 static const uint8_t MISO = 12;
 static const uint8_t SCK  = 13;
 
-static const uint8_t SDA = 18;
-static const uint8_t SCL = 19;
+static const uint8_t SDA = 21;
+static const uint8_t SCL = 22;
 static const uint8_t LED_BUILTIN = 13;
 
-static const uint8_t A0 = 17;
-static const uint8_t A1 = 18;
-static const uint8_t A2 = 19;
-static const uint8_t A3 = 20;
-static const uint8_t A4 = 21;
-static const uint8_t A5 = 22;
-static const uint8_t A6 = 23;
-static const uint8_t A7 = 24;
+static const uint8_t A0 = 0x80 & 0;
+static const uint8_t A1 = 0x80 & 1;
+static const uint8_t A2 = 0x80 & 2;
+static const uint8_t A3 = 0x80 & 3;
+static const uint8_t A4 = 0x80 & 4;
+static const uint8_t A5 = 0x80 & 5;
+static const uint8_t A6 = 0x80 & 6;
+static const uint8_t A7 = 0x80 & 7;
 
 #define digitalPinToPCICR(p)    (((p) >= 0 && (p) <= 26) ? (&PCICR) : ((uint8_t *)0))
 #define digitalPinToPCICRbit(p) (((p) <= 7) ? 2 : (((p) <= 15) ? 0 : (((p) <= 22) ? 1 : 3)))
